<template>
  <div class="page">
    <div class="ele-body">
      <a-card :bordered="false" :body-style="{ padding: '16px' }">
        <ele-pro-table
          ref="tableRef"
          row-key="id"
          :columns="columns"
          :datasource="datasource"
          :customRow="customRow"
          tool-class="ele-toolbar-form"
          class="sys-org-table"
        >
          <template #toolbar>
            <search
              @search="reload"
              :selection="selection"
              @add="openEdit"
              @remove="removeBatch"
              @batchMove="openMove"
            />
          </template>
          <template #bodyCell="{ column, record }">
            <template v-if="column.key === 'title'">
              <component v-if="record.icon" :is="record.icon" />
              {{ record.title }}
            </template>
            <template v-if="column.key === 'image'">
              <a-image :src="record.image" :width="50" />
            </template>
            <template v-if="column.key === 'path'">
              <span class="ele-text-placeholder">{{ record.path }}</span>
            </template>
            <template v-if="column.key === 'status'">
              <a-tag v-if="record.status === 0" color="green">显示</a-tag>
              <a-tag v-if="record.status === 1" color="red">隐藏</a-tag>
            </template>
            <template v-if="column.key === 'subpackage'">
              <a-tag v-if="record.subpackage === 'MainPackage'" color="orange"
                >主包</a-tag
              >
              <a-tag v-else> {{ record.subpackage }} </a-tag>
            </template>
            <template v-if="column.key === 'action'">
              <a-space>
                <a @click="openUrl(`/mp-design/${record.id}`)">设计</a>
                <a-divider type="vertical" />
                <a @click="openEdit(record)">修改</a>
                <a-divider type="vertical" />
                <a-popconfirm
                  title="确定要删除此记录吗？"
                  @confirm="remove(record)"
                >
                  <a class="ele-text-danger">删除</a>
                </a-popconfirm>
              </a-space>
            </template>
          </template>
          <template #footer>
            <div class="ele-text-secondary"
              >仓库地址：http://git.gxwebsoft.com/websoft/nbg-uniapp.git</div
            >
          </template>
        </ele-pro-table>
      </a-card>

      <!-- 编辑弹窗 -->
      <MpPagesEdit
        v-model:visible="showEdit"
        :parent-id="parentId"
        :data="current"
        @done="reload"
      />
    </div>
  </div>
</template>

<script lang="ts" setup>
  import { createVNode, ref } from 'vue';
  import { message, Modal } from 'ant-design-vue';
  import { ExclamationCircleOutlined } from '@ant-design/icons-vue';
  import { EleProTable, toTreeData } from 'ele-admin-pro';
  import { toDateString } from 'ele-admin-pro';
  import type {
    DatasourceFunction,
    ColumnItem
  } from 'ele-admin-pro/es/ele-pro-table/types';
  import Search from './components/search.vue';
  import MpPagesEdit from './components/mpPagesEdit.vue';
  import {
    pageMpPages,
    removeMpPages,
    removeBatchMpPages
  } from '@/api/cms/mpPages';
  import type { MpPages, MpPagesParam } from '@/api/cms/mpPages/model';
  import { copyText, openUrl } from '@/utils/common';

  // 表格实例
  const tableRef = ref<InstanceType<typeof EleProTable> | null>(null);

  // 表格选中数据
  const selection = ref<MpPages[]>([]);
  // 上级分类id
  const parentId = ref<number>();
  // 当前编辑数据
  const current = ref<MpPages | null>(null);
  // 是否显示编辑弹窗
  const showEdit = ref(false);
  // 是否显示批量移动弹窗
  const showMove = ref(false);
  // 加载状态
  const loading = ref(true);

  // 表格数据源
  const datasource: DatasourceFunction = ({
    page,
    limit,
    where,
    orders,
    filters
  }) => {
    if (filters) {
      where.status = filters.status;
    }
    return pageMpPages({
      ...where,
      ...orders,
      page,
      limit
    });
  };

  // 表格列配置
  const columns = ref<ColumnItem[]>([
    {
      title: 'ID',
      dataIndex: 'id',
      width: 80
    },
    {
      title: '页面名称',
      dataIndex: 'title',
      key: 'title'
    },
    {
      title: '页面路径',
      dataIndex: 'path',
      key: 'path'
    },
    {
      title: '分包',
      dataIndex: 'subpackage',
      key: 'subpackage'
    },
    {
      title: '创建时间',
      dataIndex: 'createTime',
      key: 'createTime',
      sorter: true,
      ellipsis: true,
      customRender: ({ text }) => toDateString(text, 'yyyy-MM-dd')
    },
    {
      title: '操作',
      key: 'action',
      width: 180,
      fixed: 'right',
      align: 'center',
      hideInSetting: true
    }
  ]);

  /* 搜索 */
  const reload = (where?: MpPagesParam) => {
    selection.value = [];
    tableRef?.value?.reload({ where: where });
  };

  /* 打开编辑弹窗 */
  const openEdit = (row?: MpPages | null, id?: number) => {
    current.value = row ?? null;
    parentId.value = id;
    showEdit.value = true;
  };

  /* 打开批量移动弹窗 */
  const openMove = () => {
    showMove.value = true;
  };

  /* 删除单个 */
  const remove = (row: MpPages) => {
    const hide = message.loading('请求中..', 0);
    removeMpPages(row.id)
      .then((msg) => {
        hide();
        message.success(msg);
        reload();
      })
      .catch((e) => {
        hide();
        message.error(e.message);
      });
  };

  /* 批量删除 */
  const removeBatch = () => {
    if (!selection.value.length) {
      message.error('请至少选择一条数据');
      return;
    }
    Modal.confirm({
      title: '提示',
      content: '确定要删除选中的记录吗?',
      icon: createVNode(ExclamationCircleOutlined),
      maskClosable: true,
      onOk: () => {
        const hide = message.loading('请求中..', 0);
        removeBatchMpPages(selection.value.map((d) => d.id))
          .then((msg) => {
            hide();
            message.success(msg);
            reload();
          })
          .catch((e) => {
            hide();
            message.error(e.message);
          });
      }
    });
  };

  /* 查询 */
  const query = () => {
    loading.value = true;
  };

  /* 自定义行属性 */
  const customRow = (record: MpPages) => {
    return {
      // 行点击事件
      onClick: () => {},
      // 行双击事件
      onDblclick: () => {
        openUrl(`/mp-design/${record.id}`);
      }
    };
  };
  query();
</script>

<script lang="ts">
  import * as MenuIcons from '@/layout/menu-icons';
  export default {
    name: 'MpPages',
    components: MenuIcons
  };
</script>

<style lang="less" scoped></style>
